=== debian/changelog ===
fenics-dolfinx (1:0.8.0-10) unstable; urgency=medium

  * Refresh 42c43485e81ada306f0b3f1dc735d95539174cbc.patch so that it applies
    without fuzz.
  * Require pusimp >= 0.1.1
  * Update pusimp.patch:
    - compatibility with pusimp 0.1.1
    - pin pip-installed numpy to <2.0 until debian ships numpy 2.0 too,
      otherwise numpy 2.0 would break binary compatibility in petsc4py and
      slepc4py.

 -- Francesco Ballarin <francesco.ballarin@unicatt.it>  Sat, 22 Jun 2024 12:59:48 +0000

fenics-dolfinx (1:0.8.0-9) unstable; urgency=medium

  * Drop Replaces and Conflicts with libdolfin, since they are ancient and this
    package now provides dolfinx, not dolfin.
  * Add Breaks python3-dolfinx-mpc on python3-dolfinx.
    Indeed, python3-dolfinx since 0.8.0-8 is breaking dolfinx-mpc before
    0.8.0.post1-4 because both dolfinx and dolfinx-mpc python wrappers need
    to be compiled with nanobind 2.0

 -- Francesco Ballarin <francesco.ballarin@unicatt.it>  Wed, 05 Jun 2024 09:00:14 +0000

fenics-dolfinx (1:0.8.0-8) unstable; urgency=medium

  * Build-Depends on python3-nanobind (>= 2.0.0~)

 -- Francesco Ballarin <francesco.ballarin@unicatt.it>  Sun, 02 Jun 2024 05:13:23 +0000

fenics-dolfinx (1:0.8.0-7exp1) experimental; urgency=medium

  [ Gianfranco Costamagna ]
  * debian/patches/42c43485e81ada306f0b3f1dc735d95539174cbc.patch:
    - upstream fix for newer nanobind 2.0 (Closes: #1072183)

  [ Francesco Ballarin ]
  * Fix Maintainer name of Debian Science team (routine-update)
  * Reorder sequence of d/control fields by cme (routine-update)
  * Secure URI in copyright format (routine-update)
  * Drop useless get-orig-source target (routine-update)
  * Remove trailing whitespace in debian/changelog (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * No tab in license text (routine-update)
  * Trim trailing whitespace.
  * Use secure URI in Homepage field.
  * Fix field name typo in debian/copyright (Comments vs Comment).

 -- Francesco Ballarin <francesco.ballarin@unicatt.it>  Sat, 01 Jun 2024 09:00:09 +0000

fenics-dolfinx (1:0.8.0-6) unstable; urgency=medium

  * debian patch Newton_KSP_ref_counter_PR3190.patch applies upstream
    PR3190 to fix reference counting causing a GC segfault in
    NonlinearProblems (NewtonSolver).
  * skip test-dolfinx-python-pusimp on riscv64

 -- Drew Parsons <dparsons@debian.org>  Sun, 12 May 2024 11:17:08 +0200

fenics-dolfinx (1:0.8.0-5) unstable; urgency=medium

  * debian/tests: reinstate Restrictions: allow-stderr for cpp tests.
    Needed since armhf sends C++ warnings to stderr.

 -- Drew Parsons <dparsons@debian.org>  Thu, 09 May 2024 17:14:09 +0200

fenics-dolfinx (1:0.8.0-4) unstable; urgency=medium

  * add armhf to GJK (test_cube_distance in test_gjk) skip list.
    Skip only failing arches in debian/tests.
  * align debian/tests with tests skipped in debian/rules. All tests
    should now pass except test_cube_distance and test_nonlinear_pde
    on some arches (and skip slow tests on riscv64).
  * debian/tests: remove Restrictions: allow-stderr from all tests
    (was added for legacy dolfin, should be deprecated for dolfinx)
  * skip a large number of python unit tests on riscv64, which is slow
    and times out on debci

 -- Drew Parsons <dparsons@debian.org>  Wed, 08 May 2024 18:32:43 +0200

fenics-dolfinx (1:0.8.0-3) unstable; urgency=medium

  * python3-dolfinx-real and python3-dolfinx-complex: add missing Depend on
    python3-pusimp

 -- Francesco Ballarin <francesco.ballarin@unicatt.it>  Sat, 04 May 2024 06:47:48 +0000

fenics-dolfinx (1:0.8.0-2) unstable; urgency=medium

  [ Francesco Ballarin ]
  * Add back pusimp tests, but only when internet is available
    - update pusimp.patch to test for internet availability
    - motivate internet availability in README.Debian
    - test all available python versions in autopkgtest file
      debian/tests/test-dolfinx-python-pusimp
    - testing now requires python3-requests
  * Drop http_proxy="" https_proxy="" from debian/rules, in order not
    to require internet availability while building.
  * Require restrictions: needs-internet while testing pusimp with autokpgtest

  [ Drew Parsons ]
  * move python3-jupytext, python3-matplotlib to Build-Depends-Indep
    (needed only for jupytext to build docs)
  * update debian/tests
    - add skipped numba demos (demo_static-condensation.py) to demo skip list
    - test-dolfinx-python-pusimp Depends: python3-all (for py3versions -s)

 -- Drew Parsons <dparsons@debian.org>  Fri, 03 May 2024 16:10:47 +0200

fenics-dolfinx (1:0.8.0-1) unstable; urgency=medium

  [ Francesco Ballarin ]
  * New upstream release v0.8.0
  * Build-Depends and Depends on release FEniCSx 0.8.0 components
  * Add Build-Depends on python3-jupytext, and remove former workaround
    - also requires python3-matplotlib as Build-Depends, since demos import it
  * Remove docs_no_jupytext.patch
  * Refresh patches
  * Remove consistent_dtype_PR3139.patch, which has been merged upstream

  [ Drew Parsons ]
  * skip test_nonlinear_pde on mips64el during build
  * refactor debian/tests to use bash arrays to manage python tests and
    demos to be skipped (using scipy's method)
  * debian/tests times out on riscv64, so skip the slowest python
    tests and demos and run tests with -v to monitor.
    Also skip slow build tests.
  * disable pusimp for unstable
  * set XDG_CACHE_HOME to local doc build dir when building docs in
    order to avoid /nonexistent path errors from the ffcx jit cache
    when building in a chroot without a user home (e.g. pbuilder/pdebuild)
    cf. dolfinx/jit.py l.24
  * debian patch lib_rename.patch: reintroduce cmake test for complex
    scalars (removed in 0.8) in HAVE_SCALAR_COMPLEX (removing "_PETSC")

 -- Drew Parsons <dparsons@debian.org>  Wed, 01 May 2024 20:58:24 +0200

fenics-dolfinx (1:0.8.0~git20240411.cd10d4e-5) experimental; urgency=medium

  * Require python3-pusimp and add pusimp.patch

